#!/usr/bin/perl
#
#  Copyright (C) 1998 Christian Zagrodnick
#  $Id: inetdial.cgi,v 1.5 1999/04/11 10:50:28 zagy Exp $
#  
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

use CGI "all";
# Providernames and Interfaces - only those in the list can be dialed!
# change this!
%NAMES=(
	'ippp0' => 'Boerde',
	'ippp2' => 'Freenet',
       );




# If $ONLINE_FILE.$interface exists, we are online.
$ONLINE_FILE = "/var/run/online";

# If $AUTO_FILE.$interface exists, we are in auto-hangup mode
$AUTO_FILE = "/var/run/inet_auto";

# Where to find the wrapper (SUID root, for dialing etc)
$WRAPPER="./inetdial-wrapper";

# Where to find the LOGO :-)
$LOGO="/control/inetdial-logo.jpg";

@INTERFACES=keys %NAMES;

sub status {
  local($if)=@_;
  if (!online($if)) {
    return "<font color=\"green\">no connection</font>";
  } else {
    return "<font color=\"red\">connection established</font>";
  }
} 

sub online {
  local ($if)=@_;
  stat("$ONLINE_FILE.$if");
  return -e _;
}

sub autohangup {
  local ($if)=@_;
  stat("$AUTO_FILE.$if");
  return -e _;
}

sub auth {
  local($auth);

  if (!$q->remote_user()) {
    @auth = ('none');
  } else {
    @$auth = ($q->remote_user(),'@',$q->remote_host());
  }
  return $auth; 
}

sub checkinterface {
  local($if)=@_;
  if (!$if) {
    return $INTERFACES[0];
  } else {
    $found=0;
    foreach (@INTERFACES) {
      if ($_ eq $if) {
	$found=1;
	last;
      }
    }
  }
  if (!$found) {
    return $INTERFACES[0];
  }
  return $if;
}

sub get_command {
  
  if (!$_[1]) {
    return;
  }

  local(%actions)=('DIAL' => 1,
		   'HANGUP' => 2,
		  );
  if ($_[2]) {
    $inet_auto='-A';
  }
  return "$WRAPPER -a $actions{$_[1]} -i $_[0] $inet_auto";
}

# main 
$q = new CGI;
$interface=checkinterface($q->param('interface'));
$now = localtime;
$auth = auth();
$status = status($interface); 
$refresh=60;
$action = $q->param('ACTION');
if ($action eq 'DEFAULT') {
  if (online($interface)) {
    $action='HANGUP';
  } else {
    $action='DIAL';
  }
}

$cmd=get_command($interface,$action,$q->param('INET_AUTO'));
if ($action eq 'DIAL') {
  $status="<font color=\"orange\">connecting...</font>";
  $refresh=15;
} elsif ($action eq 'HANGUP') {
  $status="<font color=\"orange\">disconnecting...</font>";
  $refresh=15; 
}

if ((online($interface)) || ($action eq 'DIAL')) {
  $q->param('ACTION','HANGUP');
  $submit_text="Hangup";
} else {
  $q->param('ACTION','DIAL');
  $submit_text="Dial";
}

 $myurl=$q->url(full=>1);
print
  $q->header(-Refresh=>"$refresh; URL=$myurl?interface=$interface"),
  $q->start_html(
		 -title=>'Inetdial',
		 -author=>'zagy@vodoo.boerde.de',
		 -BGCOLOR=>'WHITE'),
  
  $q->table({-width=>"100%"},
	    $q->Tr(
		   $q->td(
			  $q->a({-href=>'mailto: Christian Zagrodnick <zagy@gmx.net>?Subject=Inetdial'},
				$q->img({-src=>$LOGO,-alt=>"Inetdial v3.1",-border=>'0'})
			       )
			 ),
		   $q->td(
			  $q->center,
			  $q->startform,
			  $q->table(
				    $q->Tr({-bgcolor=>"#e0e0e0"},
					   $q->td(
						  $q->p({-align=>"right"},
							Auth
						       )
						  ),
					   $q->td(
						  $q->code(
							   $auth
							  )
						 )
					  ),
							   
				    $q->Tr({-bgcolor=>"#e0e0e0"},
					   $q->td(
						  $q->p({-align=>"right"},
							"Date"
						       )
						 ),
					   $q->td(
						  $q->code($now)
						 )
					  ),
				    $q->Tr({-bgcolor=>"#e0e0e0"},
					   $q->td(
						  $q->p({-align=>"right"},
							"ISP"
						       )
						  ),
					   $q->td(
						  $q->code($NAMES{$interface},
							   $q->i("($interface)")
							  )
						 )
					  ),
				    $q->Tr({-bgcolor=>"#e0e0e0"},
					   $q->td(
						  $q->p({-align=>"right"},
							Status
						       )
						 ),
					   $q->td(
						  $q->code($status)
						 )
					  ),
				    $q->Tr({-bgcolor=>"#e0e0e0"},
					   $q->td(
						  $q->center,
						  $q->checkbox(
							       -name=>'INET_AUTO',
							       -checked=>(autohangup($interface))?'checked':'',
							       -value=>(autohangup($interface))?'on':'off',
							       -label=>''
							      )
						  
						 ),
					   $q->td(
						  "Auto-Hangup"
						 )
					  )
				    ),
			  $q->center,
			  $q->hidden("ACTION"),
			  $q->submit(-name=>$submit_text),
			  $q->hidden("interface",$interface),
			  $q->endform(),
			 )
		  )
	   ),
  $q->pre(
	  qx{ $cmd }
	 ),
  $q->hr,
  "Copyright &copy; by ",
  $q->a({-href=>'mailto: Christian Zagrodnick <zagy@gmx.net>?Subject=Inetdial'},
	"Christian Zagrodnick"),
  ", distributed unter the terms of ",
  $q->a({-href=>'http://www.fsf.org/copyleft/gpl.html'},"GPL"),".",

  $q->br,
  
  $q->end_html(),
  "\n";

__END__
